#!/usr/bin/perl -w

# Takes a list of hostnames on stdin and outputs an unsigned hostlist

# usage: nodes2hostlist.pl hostlist_version port nodelist_file

my $version = shift @ARGV;
my $port = shift @ARGV;
my $nodelist = shift @ARGV;

my @hosts;
my @dirs;
my @pks;

open(FILE, $nodelist) or die "could not open nodelist: [$nodelist]\n";
while(<FILE>) {
    if (/^(\S+)\s+(\S+)\s+(\S+)\s*/) {
	push @hosts, $1;
	push @dirs, $2;
	push @pks, $3;
    } elsif (/^\s*$/) {
    } else {
	print "Ignoring error in node file: $_";
    }
}



my $max = 0xffffffff; # ffffffffffffffffffffffffffffffff;
my $inc = $max / scalar(@hosts);


print "Version $version\n";

my $id = 1;
my $i;
for ($i=0; $i<scalar(@hosts); $i++) {
    my $s = `host $hosts[$i]`;
    $s =~ /has address ([\d\.]+)/;
    
    if ($1) {
	printf "$1\t $port \t 0x%08x%032x $pks[$i] $hosts[$i]\n", $id, 1;
    }
    $id += $inc;
}
