
#ifndef __DHASH_VERIFY_H__
#define __DHASH_VERIFY_H__

#include <refcnt.h>

enum dhash_ctype;
class dbrec;

bool verify (chordID key, dhash_ctype t, const char *buf, int len);
bool verify_content_hash (chordID key,  const char *buf, int len);
bool verify_keyhash (chordID key, const char *buf, int len);

ptr<dhash_block> get_block_contents (ref<dbrec> d, dhash_ctype t);
ptr<dhash_block> get_block_contents (ptr<dbrec> d, dhash_ctype t);
ptr<dhash_block> get_block_contents (ptr<dhash_block> block, dhash_ctype t);
ptr<dhash_block> get_block_contents (const char *data, 
				     unsigned int len, 
				     dhash_ctype t);

long keyhash_version (ptr<dbrec> data);
long keyhash_version (ref<dbrec> data);
long keyhash_version (ptr<dhash_block> data);
long keyhash_version (ref<dhash_block> data);
long keyhash_version (const char *value, unsigned int len);

int keyhash_projkey (ptr<dbrec> data, bigint& k);
int keyhash_projkey (ref<dbrec> data, bigint& k);
int keyhash_projkey (ptr<dhash_block> data, bigint& k);
int keyhash_projkey (ref<dhash_block> data, bigint& k);
int keyhash_projkey (const char *value, unsigned int len, bigint& k);

bigint compute_hash (const void *buf, size_t buflen);
#endif

