#include "merkle_misc.h"

vec<merkle_hash>
database_get_keys (ptr<dhash_blockstore> storage, u_int depth, const merkle_hash &prefix)
{
  unsigned int i;
  vec<merkle_hash> ret;
  vec<ptr<dbrec> > keys;

  merkle_hash highlimit = prefix;
  for(i=depth; i<merkle_hash::NUM_SLOTS; i++) {
    u_int ones = (i == merkle_hash::NUM_SLOTS - 1) ? 0xf : 0x3f;
    highlimit.write_slot(i, ones);
  }

  // retrieve all keys matching <prefix> to <depth> slots
  storage->getchblockids(&keys, todbrec(prefix), todbrec(highlimit), 0);
  for(i=0; i<keys.size(); i++) {
    merkle_hash k = to_merkle_hash (keys[i]);
    ret.push_back (k);
  }

  return ret;
}

vec<merkle_hash>
database_get_keys_dummy (ptr<dbfe> db, u_int depth, const merkle_hash &prefix)
{
  vec<merkle_hash> ret;
  ptr<dbEnumeration> iter = db->enumerate ();
  ptr<dbPair> entry = iter->nextElement (todbrec(prefix));

  while (entry) {
    merkle_hash key = to_merkle_hash (entry->key);
    if (!prefix_match (depth, key, prefix))
      break;
    ret.push_back (key);
    entry = iter->nextElement ();
  }
  iter = NULL;
  return ret;
}
