/*
 *  Copyright (C) 2002-2004  Massachusetts Institute of Technology
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */

#ifndef PASTWATCH_IO_H
#define PASTWATCH_IO_H

#include "cfsw_prot.h"
#include "cfsr.h"
#include "cfs.h"

extern void cfsw_call (cfswcallp c);
extern void cfsr_call (cfsrcallp c);
extern void cfsr_call (bigint, cfsrcallp c);

extern void cfsr_lookup_one (bigint dir, str name, cbcfsr cb);
extern void cfsr_lookup (bigint dir, str path, cbcfsr cb);
extern void cfsr_lookup_path
  (bigint dir, str path,
   callback<void, ptr<vec<bigint> >, cfsrw_status>::ref cb);

extern void cfsw_mkdir (bigint fh, str path, cbcfsw cb);
extern void cfsw_mkdir_one (bigint dir, str name, cbcfsw cb);

#endif

