/*
 *  Copyright (C) 2005 Massachusetts Institute of Technology
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */

#ifndef PASTWATCH_METADATA_H
#define PASTWATCH_METADATA_H

#include "stdinc.h"
#include "pastwatch.h"

class info_file {
 public:
  info_file();
  ~info_file();

  int read_file(str path);

  str    get_projlabel ()   const;
  str    get_logkey ()      const;
  bigint get_projid ()      const;
  str    get_last_cr ()     const;
  str    get_branchlabel () const;

 private:
  str projlabel;
  str logkey;
  bigint projid;
  str last_cr;
  str branchlabel;
};

#endif
