#include "db_wrap.h"

int open_database ( DB *db, DB_TXN *tid, const char *file, const char *database, 
		    DBTYPE type, u_int32_t flags, int mode ) {

#if ((DB_VERSION_MAJOR < 4) || ((DB_VERSION_MAJOR == 4) && (DB_VERSION_MINOR < 1)))
  return db->open(db, file, database, type, flags, mode);
#else
  return db->open(db, tid, file, database, type, flags, mode);
#endif
}

int begin_transaction (DB_ENV *dbe, DB_TXN *parent, DB_TXN **tid, u_int32_t flags) {
#if ((DB_VERSION_MAJOR < 4) || ((DB_VERSION_MAJOR == 4) && (DB_VERSION_MINOR < 1)))
  return txn_begin(dbe, parent, tid, flags);
#else
  return dbe->txn_begin(dbe, parent, tid, flags);
#endif
}

int abort_transaction (DB_TXN *tid) {
#if ((DB_VERSION_MAJOR < 4) || ((DB_VERSION_MAJOR == 4) && (DB_VERSION_MINOR < 1)))
  return txn_abort(tid);
#else
  return tid->abort(tid);
#endif
}

int commit_transaction (DB_TXN *tid, u_int32_t flags) {
#if ((DB_VERSION_MAJOR < 4) || ((DB_VERSION_MAJOR == 4) && (DB_VERSION_MINOR < 1)))
  return txn_commit(tid, flags);
#else
  return tid->commit(tid, flags);
#endif
}

int checkpoint (DB_ENV *dbe, u_int32_t bytes, u_int32_t minutes, u_int32_t flags) {
#if ((DB_VERSION_MAJOR < 4) || ((DB_VERSION_MAJOR == 4) && (DB_VERSION_MINOR < 1)))
  return txn_checkpoint(dbe, bytes, minutes, flags);
#else
  return dbe->txn_checkpoint(dbe, bytes, minutes, flags);
#endif
}
