#ifndef _MISC_UTILS_H_
#define _MISC_UTILS_H_

#include <chord_types.h>
#include <bigint.h>
#include <str.h>
#include <vec.h>
#include <sfscrypt.h>

bool in_vector (const vec<chordID> &v, chordID N);

str gettime ();
u_int64_t getusec ();

u_int32_t uniform_random(double a, double b);
float uniform_random_f (float max);

chord_hostname my_addr ();

chord_node make_chord_node (const chord_node_wire &nl);

inline const strbuf &
strbuf_cat (const strbuf &sb, const net_address &r)
{
  sb << r.hostname << ":" << r.port;
  return sb;
}

inline const strbuf &
strbuf_cat (const strbuf &sb, const chord_node &n)
{
  sb << n.x << "@" << n.r;
  return sb;
}

inline const strbuf &
strbuf_cat (const strbuf &sb, const chord_node_wire &n)
{
  sb << make_chord_node (n); // XXX gross
  return sb;
}

str bigint2rawstr(bigint n);
str armor64A (bigint n);
bigint dearmor64A_bigint (str x);
bigint extractpid(char* buf, uint32_t len);

bool str2sfs_sig2(str s, sfs_sig2* sig);
ptr<sfspriv> read_skey (str filename);

void check_create_replicadir();

#endif /* _MISC_UTILS_H_ */
